/* Svgalib Web Browser by Clocksoft */
/* (c) 1999 Clocksoft */

#include <vga.h>
#include <vgagl.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <math.h>

#include "gvars.h"
#include "scroller.h"

#undef DEBUG_FONT_LOADER
#undef DEBUG_FONT_SCALING
#undef NOTDEF
#undef UNDEF

/******************** Global variables for f-ont loader ************************/
static unsigned char *paper; /* Temporary for loading fonts */
static int paper_width,paper_height; /* For paper */
static int decode_handle; /* For decoding font data */
static unsigned char chunk;int chunk_bits; /* Decoding font data */
static int cache_fd=-1; /* fd of the "font_cache.dat" */
static unsigned char *cache_name="font_cache.dat";
static int cache_free;
static long native_font_height;
static long native_font_width;

int write_s32_intel(int handle,long number)
{unsigned char b[4];
 b[0]=number&255;
 b[1]=(number>>8)&255;
 b[2]=(number>>16)&255;
 b[3]=(number>>24)&255;
 if (4!=write(handle,b,4))
 {
  fprintf(stderr,"Unable to write signed 32bit intel data.\n");
  return 1;
 }
 return 0;
}

int read_s32_intel(int handle,long *ptr)
{unsigned char b[4];
 if (4!=read(handle,b,4))
 {fprintf(stderr,"Unable to read signed 32bit intel data.\n");return 1;}

 *ptr=b[0]+(b[1]<<8)+(b[2]<<16)+(b[3]<<24);
 return 0;
}

inline unsigned char *
get_native_pixel_pointer(int x,int y)
{
 #ifdef DEBUG_FONT_SCALING
  if (x<0||y<0||y>=paper_height||x>=paper_width)
  {
   fprintf(stderr,"Internal error in get_native_pixel_pointer. Pixel coords "
    "out of range.\n");
   fprintf(sderr,"x=%i, y=%i, pape_width=%i, paper_height=%i.\n",x,y,
    paper_height,paper_width);
   exit(1); 
  }
 #endif /* DEBUG_FONT_SCALING */
 return paper+x+y*paper_width;
}

int inline get_native_pixel(int x,int y)
{
 #ifdef DEBUG_FONT_SCALING
 if (x<0||y<0||y>=paper_height||x>=paper_width)
  { 
   fprintf(stderr,"Internal error: get_native_pixel out of range.\n");
   fprintf(stderr,"x=%i,y=%i,paper_height=%i,paper_width=%i.\n",x,y,
    paper_height,paper_width);
   vga_setmode(TEXT);
   exit(1);
  }
 #endif 
 return paper[x+y*paper_width];
}

/* This is the new version of the routine */
unsigned char
compute_pixel_color(int x,int y)
/* Uses font_height and native_font_height to determine scaling factor for
 pixels. */
/* For left,right,top,bottom implicit denominator of font_height. */
{long gray_sum;
 int left,right,top,bottom;
 int left_pixel,right_pixel,top_pixel,bottom_pixel;
 int left_margin,right_margin,top_margin,bottom_margin;
 int area;
 /* Pixel pointer */
 unsigned char *pptr;
 
 left=x*native_font_height;right=left+native_font_height;
 top=y*native_font_height;bottom=top+native_font_height;
 left_pixel=(left+font_height-1)/font_height;
 right_pixel=right/font_height;
 top_pixel=(top+font_height-1)/font_height;
 bottom_pixel=bottom/font_height;
 gray_sum=0;
 area=font_height*font_height;
 {int areas=0;
  pptr=get_native_pixel_pointer(left_pixel,top_pixel);
  for (y=top_pixel;y<bottom_pixel;y++,pptr+=paper_width-right_pixel+left_pixel)
   for (x=left_pixel;x<right_pixel;x++)
    areas+=*pptr++;
  gray_sum+=areas*area;
 }
 left_margin=font_height-left%font_height;
 if (left_margin==font_height)left_margin=0;
 right_margin=right%font_height;
 top_margin=font_height-top%font_height;
 if (top_margin==font_height)top_margin=0;
 bottom_margin=bottom%font_height;
 if (left_margin)
 {int areas=0;
  area=left_margin*font_height;
  pptr=get_native_pixel_pointer(left_pixel-1,top_pixel);
  for(y=top_pixel;y<bottom_pixel;y++,pptr+=paper_width)
   areas+=*pptr;
  gray_sum+=areas*area;
 }
 if (right_margin)
 {int areas=0;
  area=right_margin*font_height;
  pptr=get_native_pixel_pointer(right_pixel,top_pixel);
  for (y=top_pixel;y<bottom_pixel;y++,pptr+=paper_width)
   areas+=*pptr;
  gray_sum+=areas*area; 
 }
 if (top_margin)
 {int areas=0;
  area=top_margin*font_height;
  pptr=get_native_pixel_pointer(left_pixel,top_pixel-1);
  for(x=left_pixel;x<right_pixel;x++,pptr++)
   areas+=*pptr;
  gray_sum+=areas*area;
 }
 if (bottom_margin)
 {int areas=0;
  area=bottom_margin*font_height;
  pptr=get_native_pixel_pointer(left_pixel,bottom_pixel);
  for (x=left_pixel;x<right_pixel;x++,pptr++)
   areas+=*pptr;
  gray_sum+=areas*area;
 }
 if (left_pixel>right_pixel)
 {if (top_pixel>bottom_pixel)
  {return get_native_pixel(right_pixel,bottom_pixel)?255:0;}
  if (top_margin&&get_native_pixel(right_pixel,top_pixel-1))
   gray_sum+=top_margin*native_font_height;
  if (bottom_margin&&get_native_pixel(right_pixel,bottom_pixel))gray_sum+=
   bottom_margin*native_font_height;
 }
 else
 {if (top_pixel>bottom_pixel)
  {if (left_margin&&get_native_pixel(left_pixel-1,bottom_pixel))gray_sum+=
    left_margin*native_font_height;
   if (right_margin&&get_native_pixel(right_pixel,bottom_pixel))gray_sum+=
    right_margin*native_font_height;
  }
  else
  {if (top_margin)
   {if (left_margin&&get_native_pixel(left_pixel-1,top_pixel-1))
     gray_sum+=left_margin*top_margin;
    if (right_margin&&get_native_pixel(right_pixel,top_pixel-1))
     gray_sum+=top_margin*right_margin;
   }
   if (bottom_margin)
   {if (left_margin&&get_native_pixel(left_pixel-1,bottom_pixel))
     gray_sum+=left_margin*bottom_margin;
    if (right_margin&&get_native_pixel(right_pixel,bottom_pixel))
     gray_sum+=right_margin*bottom_margin;
   }
  }
 }
 return (gray_sum*255+(native_font_height*native_font_height>>1))/
  (native_font_height*native_font_height);
}

/* Saves char number "chn" from font_img (size font_width*font_height)
   to "cache_fd". */
int
save_char(int chn)
{
 if (4+4*chn!=lseek(cache_fd,4+4*chn,SEEK_SET))
 {
  fprintf(stderr,"Unable to seek in cache.\n");
  return 1;
 }
 if (write_s32_intel(cache_fd,cache_free))
 {
  fprintf(stderr,"Unable to write char addr into cache.\n");
  return 1;
 }
 if (cache_free!=lseek(cache_fd,cache_free,SEEK_SET))
 {
  fprintf(stderr,"Can't seek to pos when writing cache.\n");
  return 1;
 }
 if (write_s32_intel(cache_fd,font_width))
 {
  return 1;
 }
 if (font_width*font_height!=write(cache_fd,font_img,font_width*font_height))
 {
  fprintf(stderr,"Unable to write image to cache.\n");
  return 1;
 }
 cache_free+=4+font_width*font_height;
 return 0;
}

void render_char(void)
{int width,height,y,x;
 unsigned char *addr;  

 width=font_width;height=font_height;
 if (width<=0) return;
 addr=font_img;
 for (y=0;y<height;y++)
 {
  for (x=0;x<width;x++)
  { 
   *addr++=compute_pixel_color(x,y);
  }
 }
}

int receive()
{int result;
 if (!chunk_bits)
 {read(decode_handle,&chunk,1);
  chunk_bits=8;
 }
 result=chunk>>7;
 chunk<<=1;
 chunk_bits--;
 return result;
}

void put_paper_pixel(int x,int y,int value)
{if (x<0||y<0||x>=paper_width||y>=paper_height) return;
 paper[x+y*paper_width]=value;
}

void decode(int l,int r,int t,int b)
{int lr,tb;
 
 if (l==r||t==b) return; /* Nothing to decode */
 if (r==l+1&&b==t+1) {put_paper_pixel(l,t,receive());return;}
 if (!receive()) return; /* No block zero needed: done by calloc :-) */
 lr=(l+r)>>1;
 tb=(t+b)>>1;
 decode(l,lr,t,tb);
 decode(lr,r,t,tb);
 decode(l,lr,tb,b);
 decode(lr,r,tb,b);
}

void integrate(int width)
{int x,y,sum;
 unsigned char *p=paper;
 
 for (y=paper_height;y;y--)
 {sum=0;
  for (x=width;x;x--)
  {sum^=*p;
   *p=sum;
   p++;
  }
  p+=paper_width-width;
 }  
}

int load_char(int handle)
{int width=native_font_width;

 decode_handle=handle;
 chunk_bits=0;
 decode(0,width,0,paper_height);
 integrate(width);
 return 0;
}

int load_encoding_table()
/* Takes the actual_encoding and loads encoding table. */
{FILE *f;
 /* For generating various strings */
 unsigned char *txt;
 int n,e,u;

 /* First we'll assembly the full filename. */
 txt=malloc(strlen(actual_encoding->fname)+strlen(path)+1);
 if (!txt)
 {
  fprintf(stderr,"Unable to malloc few bytes for concatenating path and "
   "encoding filename.\n");
  return 1;
 }
 strcpy(txt,path);
 strcat(txt,actual_encoding->fname);
 f=fopen(txt,"r");
 if (!f)
 {
  fprintf(stderr,"Unable to open file %s.\n",txt);
  return 1;
 }
 free(txt);
 if (!(txt=malloc(257)))
 {
  fprintf(stderr,"Unable to alloc 257 byte buffer for reading "
   "encoding table.\n");
  return 1;
 }
 bzero(encoding,sizeof(encoding));
 while(!feof(f))
 {
  fgets(txt,257,f);
  n=sscanf(txt,"%x%x",&e,&u);
  if (n!=2) continue;
  encoding[e&255]=u;
 }
 free(txt);
 fclose(f);
 #ifdef DEBUG_FONT_LOADER
  printf("load_encoding_table successfully returns.\n");
 #endif
 return 0;
}

/* Return value: 0 ok
                 1 fatal error
                 2 non-fatal error*/
int
open_cache(void)
{
 int len=strlen(path)+strlen(cache_name); 
 unsigned char *p;
 long tmp;

 p=malloc(len+1);
 if (!p)
 {
  fprintf(stderr,"Out of memory when assembling filename for testing cache"
   "presence.\n");
  return 1;
 }
 strcpy(p,path);
 strcat(p,cache_name);
 cache_fd=open(p,O_RDONLY);
 free(p);
 if (cache_fd<0)
 {
  return 2;
 }
 if (read_s32_intel(cache_fd,&tmp))
 {
  fprintf(stderr,"Unable to read cache height.\n");
  return 1;
 }
 if (tmp!=required_font_height) 
 {
  close(cache_fd);
  return 2;
 }
 if (0!=lseek(cache_fd,0,SEEK_SET))
 {
  fprintf(stderr,"Unable to seek when reading cache.\n");
  return 1;
 }
 return 0;
}

/* Refers to the "font_cache.dat". */
void
close_cache(void)
{
 close(cache_fd);
}

/* Uses the "cache_fd". Loads raw 256-level gray data.
   Format of the cache:
   read the file "font_loader.doc"
   return value: 0 ok
                 1 fatal error
*/
int
load_from_cache(void)
{
 int l,chn;
 long char_addr;

 if (read_s32_intel(cache_fd,&font_height))
 {fprintf(stderr,"Load from cache: Unable to read font height.\n");
  return 1;
 }
 if (font_height!=required_font_height)
 {
  fprintf(stderr,"Font cache load: bad height.\n");
  return 1;
 }
 for (chn=0;chn<256;chn++)
 {
  if (4+encoding[chn]*4!=lseek(cache_fd,4+encoding[chn]*4,SEEK_SET))
  {fprintf(stderr,"Load from cache: Unable to seek to char addr.\n");
   return 1;
  }
  if (read_s32_intel(cache_fd,&char_addr))
  {fprintf(stderr,"Load from cache: Unable to read char addr.\n");
   return 1;
  }
  if (!char_addr)
  {font_widths[chn]=0;
   continue;
  }
  if (char_addr!=lseek(cache_fd,char_addr,SEEK_SET)||read_s32_intel(cache_fd,
   font_widths+chn))
  {
   fprintf(stderr,"Unable to load char #%i width.\n",chn);
   return 1;
  }
  if (font_widths[chn]<0)
  {fprintf(stderr,"Font cache format error: char %i has negative width.\n",chn);
   return 1;
  }
 }
 font_width=0;
 for (chn=0;chn<256;chn++)
 {
  font_stops[chn]=font_width;
  font_width+=font_widths[chn];
 }
 if (font_width<=0)
 {
  fprintf(stderr,"Font cache invalid: font width=%li.\n",font_width);
  return 1;
 }
 if (!(font_img=(unsigned char *)calloc(font_height,font_width)))
 {
  fprintf(stderr,"Unable to malloc %li bytes for font image.\n",font_width*
   font_height);
  return 1;
 }
 for (chn=0;chn<256;chn++)
 {
  if (4+encoding[chn]*4!=lseek(cache_fd,4+encoding[chn]*4,SEEK_SET)||
   read_s32_intel(cache_fd,&char_addr)||
   char_addr+4!=lseek(cache_fd,char_addr+4,SEEK_SET))
  /* Seek directly to char data, skip char width. */
  {
   fprintf(stderr,"Unable to seek to char data of char #%i.\n",chn);
   return 1;
  }
  for (l=0;l<font_height;l++)
  {
   if (font_widths[chn]!=read(cache_fd,font_img+font_stops[chn]+
    l*font_width,font_widths[chn]))
   {
    fprintf(stderr,"Unable to read char %i, microline %i.\n",chn,l);
    return 1;
   }
  }
 }
 return 0;
}

/* Takes bit-encoded raw font data and scales them down to make the cache file.
   return value: 0 ok
                 1 error
*/
int
generate_cache(void)
{
 unsigned char *txt;
 int chn;
 int handle;
 long char_addr;
 
 txt=malloc(strlen(actual_font_name)+strlen(path)+1);
 if (!txt)
 {fprintf(stderr,"Unable to alloc small buffer for concatenating font path and"
 "font filename.\n");
  return 1;
 }
 #ifdef DEBUG_FONT_LOADER
  printf("font_loader: path=%s.\n",path);
 #endif
 strcpy(txt,path);
 strcat(txt,actual_font_name);
 handle=open(txt,O_RDONLY);
 if (handle<0)
 {
  fprintf(stderr,"Unable to open font file %s.\n",txt);
  return 1;
 }
 free(txt);
 txt=malloc(strlen(cache_name)+strlen(path)+1);
 if (!txt)
 {
  fprintf(stderr,"Out of memory for concatenting path and cache name.\n");
  return 1;
 }
 strcpy(txt,path);
 strcat(txt,cache_name);
 cache_fd=open(txt,O_CREAT|O_WRONLY|O_TRUNC,0666);
 if (cache_fd<0)
 {
  fprintf(stderr,"Unable to open cache file %s for writing.\n",txt);
  return 1;
 }
 free(txt);
 cache_free=65536*4+4;
 font_height=required_font_height;
 if (write_s32_intel(cache_fd,font_height))
 {
  fprintf(stderr,"Unable to write cache height.\n");
  return 1;
 }
 if (cache_free!=lseek(cache_fd,cache_free,SEEK_SET))
 {
  fprintf(stderr,"Unable to seek in cache.\n");
  return 1;
 }
 if (read_s32_intel(handle,&native_font_height))
 {
  fprintf(stderr,"Unable to read native font height.\n");
  return 1;
 }
 for (chn=0;chn<65536;chn++)
 {
  if (4+chn*4!=lseek(handle,4+chn*4,SEEK_SET))
  {
   fprintf(stderr,"Unable to seek to char addr.\n");
   return 1;
  }
  if (read_s32_intel(handle,&char_addr))
  {
   fprintf(stderr,"Unable to read char addr.\n");
   return 1;
  }
  if (!char_addr)
  {
   continue;
  }
  if (char_addr!=lseek(handle,char_addr,SEEK_SET)||read_s32_intel(handle,
   &native_font_width))
  {
   fprintf(stderr,"Unable to load char #%i width.\n",chn);
   return 1;
  }
  if (native_font_width<0)
  {
   fprintf(stderr,"Font format error: char %i has negative width %li.\n",chn,
    native_font_width);
   return 1;
  }
  font_width=(native_font_width*font_height+native_font_height-1)/
   native_font_height;
  if (font_width<=0)
  {
   fprintf(stderr,"Font invalid: font width=%li.\n",font_width);
   return 1;
  }
  font_img=(unsigned char *)calloc(font_height,font_width);
  if (!font_img)
  {
   fprintf(stderr,"Unable to calloc %li bytes for font image.\n",font_width*
    font_height);
   return 1;
  }
  paper_width=(font_width*native_font_height+font_height-1)/font_height;
  paper_height=native_font_height;
  if (!paper_width) continue; /* Empty char, nothing to load */
  if (!(paper=(unsigned char *)calloc(paper_width,paper_height)))
  {
   fprintf(stderr,"Too few memory to alloc %i bytes for loading char image"
    " #%i.\n",paper_width*paper_height,chn);
   return 1;
  }
  if (load_char(handle)) /* From handle to paper */
  {
   fprintf(stderr,"Unable to load char image #%i.\n",chn);
   return 1;
  }
  render_char(); /* From paper to font_img */
  save_char(chn);
  free(paper);
  free(font_img);
 }
 close(handle);
 close(cache_fd);
 #ifdef DEBUG_FONT_LOADER
  printf("Font loader successfully returns.\n");
 #endif
 return 0;
}

int font_loader(void)
{
 free(font_img);
 if (required_font_height<1)
 {
  fprintf(stderr,"Bad required font height");
  return 1;
 }
 #ifdef DEBUG_FONT_LOADER
  printf("Font loader.\n");
 #endif
 switch(open_cache())
 {
  case 0:
  break;
  
  case 1:
  fprintf(stderr,"Fatal error while trying to open font cache.\n");
  return 1;
  case 2:
  #ifdef DEBUG_FONT_LOADER
   printf("Cache not present. Trying to generate.\n");
  #endif
  if (generate_cache())
  {
   fprintf(stderr,"Unable to generate cache.\n");
   return 1;
  }
  #ifdef DEBUG_FONT_LOADER
   printf("Cache generated.\n");
  #endif
  if (open_cache())
  {
   fprintf(stderr,"Unable to open cache after successfully generating it.\n");
   return 1;
  }
  break;
 }
 #ifdef DEBUG_FONT_LOADER
  printf("Cache opened.\n");
 #endif
 if (load_encoding_table())
 {
  fprintf(stderr,"Unable to load encoding table.\n");
  return 1;
 }
 #ifdef DEBUG_FONT_LOADER
  printf("Encoding table loaded.\n");
 #endif
 if (load_from_cache())
 {
  fprintf(stderr,"Unable to load font from cache though the case should exist"
   ".\n");
  return 1;
 }
 #ifdef DEBUG_FONT_LOADER
  printf("Leaving font_loader.\n");
  printf("font_img=%lu, font_width=%li, font_height=%li.\n",(unsigned long)
   font_img,font_width,font_height);
  printf("required_font_height=%li.\n",required_font_height);
 #endif
 close_cache();
 return 0;
}
