extern int scroller(int command,void *params);

struct lineno_desc
{
 int lineno;
 int number;
 unsigned char *ptr;
};

struct
char_desc
{
 unsigned char br,bg,bb,fr,fg,fb;
 unsigned char type; /* 0..4 boxes, 5 normal char */
 unsigned long code; /* Char code or length of the box */
};

enum{

/* Add line, parameter is a pointer on a block_desc, which contains pointer
to text and text length. No zero terminators. */
SC_ADD_LINE,

/* Add line of text broken down because of image mode. Does nothing in text
 * mode. Parameter is a lineno_desc. The lineno is number of scanline. */
SC_ADD_LINENO,

/* Like SC_ADD_LINE, but adds only one microline in image mode. */
SC_ADD_MICRO_LINE,

/* Like SC_ADD_MICOR_LINE, but also the number of the line is specified. */
SC_ADD_MICRO_LINENO,

/* Shift one line up after pressing "UP" key */
/* Does nothing when at beginning. */
SC_LINE_UP,

/* Shift one line down after pressing "DOWN" key */
/* Does nothing when at end. */
SC_LINE_DOWN,

/* Shift one page up after pressing pgup key. */
/* Clips at the beginnnig */
SC_PAGE_UP,

/* Shift one page down after pressing pgdn key */
SC_PAGE_DOWN,

/* Goes to the first line after pressing home key */
SC_HOME,

/* Goes to a position where the last line is at the bottom of the screen. */
/* When number of lines is less than number of lines which fit on the screen,
   goes on the first line. */
SC_END,

/* New screen.
   Recomputes top_lines, page_skip, frees all lines.
   Goes to the first line. Clears the top part of screen.
   params=int *, is assigned into image_mode;
   Resets highlighted window.
   when image_mode==1:
                     top_lines is computed differently
		     page_skip is different
		     Clears the top part of the screen
		     Sets xoff=0
*/
SC_NEW_SCREEN,

/* New font */
/* Recomputes top_lines, page_skip,
   goes to the first line,
   clears the top part of screen.
   Resets highlighted window.
*/
SC_NEW_FONT,

/* parameter=pointer to a block_desc definig the line to be displayed.
   Line is displayed from the leftmost position of status line (whose pixels
   are contained in sl variable) and the sl is erased between the end of the
   message and right edge of the sl. If longer than sl, clipped.
*/
SC_DISPLAY_LINE,

/* An action caused by pressing right arrow */
SC_LEFT,

/* Caused by pressing left arrow */
SC_RIGHT,

/* Prints the immediate contets of the page */
SC_PRINT,

/* Sets up vga graphics mode and maybe loads the vga palette. Recomputes 
   gamma_lut */
SC_SETUP_VGA_MODE,

/* Sets up gamma, reloads gamma_lut, maybe changes palette. Redraws all things
   onscreen. Parameter is NULL.
 */
SC_COLOR_CURVES_CHANGED
};

extern double monitor_gamma_r,
       monitor_gamma_g,
       monitor_gamma_b,
       required_gamma,
       monitor_mul_r,
       monitor_mul_g,
       monitor_mul_b,
       monitor_shift_r,
       monitor_shift_g,
       monitor_shift_b;

extern int vga_linewidth; /* Prepared out from vga_getmodeinfo */
extern int xsize,ysize; /* Prepared out from vga_getmodeinfo */
extern int vga_bytes; /* Prepared out from vga_getmodeinfo */
extern int vga_colors; /* prepared out from vga_getmodeinfo */
extern int vga_linear; /* 1 linear mode, 0 nonlinear mode (paged) */
extern int vga_misordered; /* The same meaning as misordered in vga_getmodeinfo */ 
extern unsigned char image_mode;
extern void round_pixel(unsigned char *dest, int *r, int *g, int *b);

/* Interpreted commands of scroller
   0 length char char char...  A block of text
   1 length0 length1 length2 lenght3 char char ... A block of text >=256 bytes
   2 bgcolor_r bgcolor_g bgcolor_b Set background color
   3 fgcolor_r fgcolor_g fgcolor_b Set foreground color
*/
